/****** CopyRightBegin *******************************************************/
/*                                                                           */
/* Copyright (C) 1996 TU-Muenchen LIS All Rights Reserved.                   */
/*                                                                           */
/****** CopyRightEnd *********************************************************/

#ifndef _READPARA
#define _READPARA

/******* SCCSInfo ************************************************************/
/* Filename :    $RCSfile: readparam.h,v $
   Version  :    $Revision: 1.2 $
   Last Edit:    $Date: 2000/08/02 10:17:50 $ 
   Released :    %D% %T%   */
/******* SCCSInfo ************************************************************/

///////////////////////////////////////////////////////////////////////////////
//
// This software module was originally developed by
//
// S. Herrmann TU-Munich, Institute for Integrated Circuits
// (contributing organizations names)
//
// in the course of development of the MPEG-7 Experimentation Model.
//
// This software module is an implementation of a part of one or more MPEG-7
// Experimentation Model tools as specified by the MPEG-7 Requirements.
//
// ISO/IEC gives users of MPEG-7 free license to this software module or
// modifications thereof for use in hardware or software products claiming
// conformance to MPEG-7.
//
// Those intending to use this software module in hardware or software products
// are advised that its use may infringe existing patents. The original
// developer of this software module and his/her company, the subsequent
// editors and their companies, and ISO/IEC have no liability for use of this
// software module or modifications thereof in an implementation.
//
// Copyright is not released for non MPEG-7 conforming products. The
// organizations named above retain full right to use the code for their own
// purpose, assign or donate the code to a third party and inhibit third parties
// from using the code for non MPEG-7 conforming products.
//
// Copyright (c) 1998-1999.
//
// This notice must be included in all copies or derivative works.
//
// Applicable File Name:  readparam.h
//

/******* INCLUDES ************************************************************/

/******* DEFINES *************************************************************/
#if defined(__cplusplus) || defined(c_plusplus)
extern "C" {
#endif

/******* MAKROS  *************************************************************/

/******* TYPES ***************************************************************/

/******* VARIABLES ***********************************************************/
extern char *parfilename;   /*name of parameterfile*/

/******* FUNCTIONS ***********************************************************/

void readparameters(char *parameterfile);
  /* Lesen einer Parameterdatei in einen
     Pufferspeicher (lokal in readparam.c)*/

char  *getpara(char *param, char *deflt);
  /* Ermittel eines Parameterwertes aus dem Puffer
     Reuckgabe von default, wenn der Parameter nicht
     existiert*/

int  testpara(char *param);
  /* Testen ob der Parameter im Puffer existiert*/

char *strtrunc(char *string);
  /* Entfernen von Leerzeichen am Ende eines Strings*/

#if defined(__cplusplus) || defined(c_plusplus)
}
#endif

#endif




